exodus/exodus/urls.py
from django.conf import settings
from django.urls import include, path
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin

from . import views

urlpatterns = [
    path('i18n/', include('django.conf.urls.i18n')),
    path('api/', include('restful_api.urls')),
    path('admin/', admin.site.urls),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework')),
]

urlpatterns += i18n_patterns(
    path('', views.index, name='home'),
    path('analysis/', include('analysis_query.urls')),
    path('trackers/', include('trackers.urls')),
    path('reports/', include('reports.urls')),
    path('info/permissions/', views.permissions, name='permissions'),
    path('info/trackers/', views.trackers, name='trackers'),
    path('info/next/', views.next, name='next'),
    path('info/understand/', views.understand, name='understand'),
    path('info/organization/', views.organization, name='organization'),
)

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

# handler404 = 'exodus.views.page_not_found'
# handler500 = 'exodus.views.page_not_found'

exodus/reports/urls.py
from django.urls import path
from django.views.generic import RedirectView

from . import views

app_name = 'reports'
urlpatterns = [
    path('', views.index, name='index'),
    path('list/', views.get_reports, name='list'),
    path('<int:report_id>/', views.detail, name='detail'),
    path('<int:app_id>/icon/', views.get_app_icon, name='icon'),
    path('stats/', RedirectView.as_view(pattern_name='trackers:get_stats', permanent=False)),
    path('search/<handle>/', views.get_reports, name='search_by_handle'),
    path('<handle>/latest/', views.detail, name='get_latest'),
    path('<handle>/latest/icon/', views.get_app_icon, name='icon_by_handle'),
]

exodus/web/templates/snippets/paginator.html
{% load i18n %}
{% load url_replace %}
<ul class="pagination pagination-sm justify-content-center">
  {% if reports.has_previous %}
    <li class="page-item">
      <a class="page-link" href="?{% url_replace request 'page' 1 %}">{% trans "First" %}</a>
    </li>
    <li class="page-item">
      <a class="page-link" href="?{% url_replace request 'page' reports.previous_page_number %}">{% trans "Previous" %}</a>
    </li>
  {% else %}
    <li class="page-item disabled">
      <a class="page-link" href="#">{% trans "First" %}</a>
    </li>
    <li class="page-item disabled">
      <a class="page-link" href="#">{% trans "Previous" %}</a>
    </li>
  {% endif %}
  {% for i in reports.paginator.page_range %}
    {% if i > reports.number|add:'-5' and i < reports.number|add:'5' %}
      {% if i == reports.number %}
        <li class="page-item active">
          <a class="page-link" href="?{% url_replace request 'page' i %}">{{ i }}</a>
        </li>
      {% else %}
        <li class="page-item">
          <a class="page-link" href="?{% url_replace request 'page' i %}">{{ i }}</a>
        </li>
      {% endif %}
    {% endif %}
  {% endfor %}
  {% if reports.has_next %}
    <li class="page-item">
      <a class="page-link" href="?{% url_replace request 'page' reports.next_page_number %}">{% trans "Next" %}</a>
    </li>
    <li class="page-item">
      <a class="page-link" href="?{% url_replace request 'page' reports.paginator.num_pages %}">{% trans "Last" %}</a>
    </li>
  {% else %}
    <li class="page-item disabled">
      <a class="page-link" href="#">{% trans "Next" %}</a>
    </li>
    <li class="page-item disabled">
      <a class="page-link" href="#">{% trans "Last" %}</a>
    </li>
  {% endif %}
</ul>

exodus/web/templates/snippets/reports_links.html
{% load i18n %}
<div class="row justify-content-center mb-4">
  <div class="col-lg-8 col-sm-12">
    <h4>{% trans "Need an overview?" %}</h4>
  </div>
</div>

<div class="row justify-content-center mb-4">
  <div class="col-lg-6 col-sm-8 text-right">
    <a href="{% url 'reports:list' %}" class="link main-link">{% trans "Latest reports" %}</a>
  </div>
</div>

<div class="row justify-content-center mb-4">
  <div class="col-lg-6 col-sm-8 text-right">
    <a href="{% url 'reports:list' %}?filter=no_trackers" class="link main-link">{% trans "No known trackers" %}</a>
  </div>
</div>

<div class="row justify-content-center mb-4">
  <div class="col-lg-6 col-sm-8 text-right">
    <a href="{% url 'reports:list' %}?filter=most_trackers"
      class="link main-link">{% trans "Sorted by number of trackers" %}</a>
  </div>
</div>

exodus/web/templates/snippets/reports_search.html
{% load i18n %}
<div class="row justify-content-center mb-5">
  <div class="col-lg-8 col-sm-12">
    <div class="form-group">
      <h4>{% trans "Search a report" %}</h4>
      <label for="query"><b>{% trans "Application name" %}</b></label>
      <div class="input-group input-group-lg mb-3">
        <div class="input-group-prepend">
          <span class="input-group-text" id="query_help">
            <small><img src="/static/img/search.svg" alt="search"></small>
          </span>
        </div>
        <input type="text" class="form-control" id="query" aria-describedby="query_help">
      </div>
      <small class="form-text text-muted mb-4">
        {% trans "You can search for an application using its name, handle or Google Play URL" %}
        <br>
        <i>{% trans "ex:" %} <b>Meteo France</b> {% trans "or" %} <b>fr.meteo</b> {% trans "or" %}
          <b>https://play.google.com/store/apps/details?id=fr.meteo</b></i>
        <br>
        {% blocktrans trimmed with url='<a href="https://play.google.com/store/apps" target="_blank">Google Play</a>' %}
        Cannot find the application? Search it in {{ url }}.
        {% endblocktrans %}
      </small>
      <div id="go-div" class="row justify-content-center">
        <div class="col-8 col-sm-7 col-md-6 col-xl-5">
          <button id="go" class="btn btn-primary btn-block">{% trans "Let's go!" %}</button>
        </div>
      </div>
      <h4 style="display: none" id="results-title">{% trans "Results" %}</h4>
      <div id="results" style="display: none">
      </div>
    </div>
  </div>
</div>

exodus/web/templates/snippets/reports_search_tpl.html
{% load i18n %}
{% verbatim %}
<script id="tpl" style="display:none;" type="text/x-handlebars-template">
  <div class="container">
    {{#unless results.length}}
      {% endverbatim %}<h5>{% trans "No results found." %}</h5>{% verbatim %}
    {{/unless}}
    {{#each results}}
      <br>
      <div class="row position-relative">
        <div class="col-3 col-sm-2 col-md-2 my-auto">
          <img class="rounded" src="/reports/{{handle}}/latest/icon" width="50" alt="{{handle}} logo">
        </div>
        <div class="col-9 col-sm-10 col-md-10 text-truncate position-static">
          <div>
            <a href="/reports/{{handle}}/latest" class="stretched-link report-link">
              {{#if name}}
                {{name}}
              {{else}}
                {{handle}}
              {{/if}}
            </a>
          </div>
          <div class="small"><b>{{version}}</b></div>
          <div>
            <span class="mr-lg-4 mr-2">
              <span class="badge badge-pill badge-{{trackers_class}} reports">{{trackers_count}}</span>
              {% endverbatim %}{% trans "tracker(s)" %}{% verbatim %}
            </span>
            <span>
              <span class="badge badge-pill badge-{{permissions_class}} reports">{{permissions_count}}</span>
              {% endverbatim %}{% trans "permission(s)" %}{% verbatim %}
            </span>
          </div>
        </div>
      </div>
    {{/each}}
  </div>
</script>
{% endverbatim %}

<script>
  const tpl_source = document.getElementById("tpl").innerHTML;
  const tpl = Handlebars.compile(tpl_source);
  jQuery(function () {
    jQuery("#query").focus();
  });
  const display_results = function (results) {
    jQuery("#go-div").hide()
    jQuery("#results").hide()
    jQuery("#results-title").hide()
    jQuery("#results").html("")
    jQuery("#results").html(tpl(results))
    jQuery("#results").show()
    if (results.results.length > 0) {
      jQuery("#results-title").show()
    }
  }
  jQuery.fn.enterKey = function (fnc) {
    return this.each(function () {
      $(this).keypress(function (ev) {
        var keycode = (ev.keyCode ? ev.keyCode : ev.which);
        if (keycode == '13') {
          fnc.call(this, ev);
        }
      })
    })
  }
  const get_results = function (query, limit) {
    jQuery.ajax({
      type: 'POST',
      url: "/api/search",
      data: '{"type": "application", "query":"' + query + '", "limit":' + limit + '}',
      success: display_results,
      contentType: "application/json",
      dataType: 'json'
    })
  }
  jQuery("#go").on("click", function () {
    const query = jQuery.trim(jQuery("#query").val())
    get_results(query, 50)
  })

  var search_timer = 0

  jQuery("#query").on("change paste keyup", function () {
    if (search_timer) {
      clearTimeout(search_timer)
    }
    const query = jQuery.trim(jQuery(this).val())
    if (query.length >= 5) {
      // Extract handle from Google Play or F-Droid url
      const gplay_regex = /id=((?:\w+\.)+\w+)/gmi;
      const fdroid_regex = /packages\/((?:\w+\.)+\w+)/gmi;
      if (query.startsWith("https://play.google.com")) {
        var match = gplay_regex.exec(query)
        while (match != null) {
          if (match[1]) {
            jQuery(this).val(match[1])
          }
          return
        }
      } else if (query.startsWith("https://f-droid.org/")) {
        var match = fdroid_regex.exec(query)
        while (match != null) {
          if (match[1]) {
            jQuery(this).val(match[1])
          }
          return
        }
      }

      search_timer = setTimeout(function () { get_results(query, 20); }, 200);
    }
    if (query == '') {
      jQuery("#go-div").show()
      jQuery("#results").hide()
      jQuery("#results-title").hide()
    }
  });
  jQuery("#query").enterKey(function () {
    const query = jQuery.trim(jQuery("#query").val())
    get_results(query, 50)
  });
</script>